#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <sched.h>
#include "task.h"
#include "time_utils.h"

enum mode_t {NORMAL, EMERGENCY};

int check_deadline(struct timespec *d)
{
    struct timespec now;
    clock_gettime(CLOCK_REALTIME, &now);
    int flag = timespec_cmp(d, &now);
    if (flag < 0) return 0;
    else return 1;
}

void set_priority(int prio) 
{
    struct sched_param param;
    param.sched_priority = prio;
    sched_setscheduler(pthread_self(), SCHED_FIFO, &param);
}

void *taskbody(void *arg) 
{
    task_data_t data = *((task_data_t *)arg);
    int nmiss;
    int mode = NORMAL;
    int check;
    struct timespec next;
    
    set_priority(data.priority);
    clock_gettime(CLOCK_REALTIME, &next);
    while (1) {
        printf("Task %d: Parte obbligatoria\n", data.index);
        
        if (mode == NORMAL) {
            printf("Task %d: Parte opzionale\n", data.index);
        }
        
        timespec_add_us(&next, data.period);
        check = check_deadline(&next);
        
        if (!check && mode == NORMAL) {
            nmiss = 1;
            mode = EMERGENCY;
        }
        else if (!check && (mode == EMERGENCY)) {
            nmiss++;
            if (nmiss > data.n_i) {
                printf("Task %d: troppe deadline miss consecutive, ABORT\n", 
                       data.index);
                exit(-1);
            }
        }
        else if (check && (mode == EMERGENCY)) {
            nmiss = 0;
            mode = NORMAL;
        }
        
        printf("Task %d: sleeping\n", data.index);
        clock_nanosleep(CLOCK_REALTIME, TIMER_ABSTIME, &next, 0);    
    }
    return 0;
}
